import traceback

import requests
from hombre.utils.postgres_wrapper import execute_query


def start(age):
    base_url = "https://nsx-config/intelligence/config/full-sync/"
    roles = {'X-Nsx-Roles': 'ZW50ZXJwcmlzZV9hZG1pbgo='}
    cert_file = '/etc/nsxi/store/tls.crt'
    key_file = '/etc/nsxi/store/tls.key'
    cacert_file = '/etc/nsxi/store/ca.crt'
    try:
        print("Starting full sync for sites older than " + str(age) + " days")
        query = "SELECT DISTINCT orgid, siteid FROM normalizedsiteconfig"
        result = execute_query(query_string=query, params="", fetch_post_exec=True)
        site_to_org = {}
        for row in result:
            site_to_org[row[1]] = row[0]
        query = """SELECT DISTINCT site_id FROM policynsxconfigepoch WHERE
        TO_TIMESTAMP(policynsxconfigepoch.starttime/1000) < now() - interval '{} days'""".format(age)
        result = execute_query(query_string=query, params="", fetch_post_exec=True)
        for row in result:
            site_id = row[0]
            org_id = site_to_org.get(site_id)
            if org_id is None:
                print("Org-id not found for site: " + str(site_id))
                continue
            url = base_url + "org/" + str(org_id) + "/site/" + str(site_id)
            print("Starting full sync for site " + str(site_id))
            response = requests.post(url, headers=roles, cert=(cert_file, key_file), verify=cacert_file)
            print("Response to full sync request to nsx-config: " + str(response))
    except Exception as e:
        print("Got exception while executing request: " + str(e))
        print(traceback.format_exc())
        raise
